package jp.oarts.pirka.iop.tool.core.business;

import java.io.Serializable;

import jp.oarts.pirka.iop.tool.core.general.constants.AttributeType;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeData;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataItem;
import jp.oarts.pirka.iop.tool.core.general.vo.Selecter;

/**
 * ڃC^[tF[X
 *
 * @author ito
 *
 */
public interface AttributeItem extends Serializable {

	/**
	 * ڃL[擾
	 *
	 * @return ڃL[
	 */
	public String getName();

	/**
	 * ړ{L[擾
	 *
	 * @return ړ{L[
	 */
	public String getNameJp();

	/**
	 * ڐbZ[W擾
	 *
	 * @return ڐbZ[W
	 */
	public String getMessage();

	/**
	 * ^Cv擾
	 *
	 * @return	^Cv
	 */
	public AttributeType getAttributeType();

	/**
	 * ړ͒擾
	 *
	 * @return ړ͒
	 */
	public int getLength();

	/**
	 * ftHgl擾
	 *
	 * @return	ftHgl
	 */
	public AttributeData getDefaultValue();

	/**
	 * ZNgpXg擾
	 *
	 * @return	ZNgpXg
	 */
	public Selecter[] getSelecter();

	/**
	 * ͒l̃`FbN
	 *
	 * @param value
	 *            ͒l
	 * @param item
	 *            C^[tF[X
	 * @throws InterfaceException
	 *             G[messageɃG[i[ē邱
	 */
	public void check(String value, InterfaceDataItem item) throws InterfaceException;


	/**
	 * A^b`񃁃eiXʂŏɃftHgl\邩̃tO
	 * @return	true=ftHgl\
	 */
	public boolean isAlwaysDefaultValue();

}
