package jp.oarts.pirka.iop.tool.core.business;

import java.util.HashMap;
import java.util.TreeMap;

import jp.oarts.pirka.iop.tool.core.general.constants.PluginType;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeData;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeFileImage;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;

/**
 * t@CNG[^[vOCATvf[vOCC^[tF[X
 *
 * @author ito
 *
 */
public interface FileCreatorSampleModelerPlugin extends Plugin {

	/**
	 * ̃Rg擾
	 *
	 * @return ̃Rg
	 */
	public String getAttributeComment();

	/**
	 * vOC^Cv̎擾
	 *
	 * @return vOC^Cv
	 */
	public PluginType getPluginType();

	/**
	 * C^[tF[XɃA^b`\ׂ
	 *
	 * @return true=A^b`\
	 */
	public boolean canAttach();

	/**
	 * s\ȃvOC
	 *
	 * @return true=s\Afalse=s\
	 */
	public boolean canExecute();

	/**
	 * ̃vOC̃Ab^`C^[tF[Xɕt鑮ڂ̈ꗗ擾
	 *
	 * @return ڂ̈ꗗ
	 */
	public AttributeItem[] getAttributeItems();

	/**
	 * ̃vOC̃Ab^`C^[tF[Xɕt鑮ڎ擾
	 *
	 * @param name
	 *            ږ
	 * @return 
	 */
	public AttributeItem getAttributeItem(String name);

	/**
	 * ڃ`FbNsOɌĂяo<BR>
	 * 莩IɃC^[tF[X̕ύXȂǂsƂɎgp<BR>
	 * G[G[bZ[WInterfaceExceptionɃZbgē
	 *
	 * @param dataId
	 *            C^tF[XID
	 * @param dataMap
	 *            Sf[^}bv(L[FC^[tF[XAlFIDi[}bviL[FC^tF[XIDAlFڑli[}bvi
	 *            L[FږAlFljjj
	 * @param interfaceProject
	 *            C^tF[XvWFNg
	 * @throws InterfaceException
	 */
	public void preCheckAttribute(int dataId, HashMap<String, TreeMap<Integer, HashMap<String, AttributeData>>> dataMap,
			InterfaceProject interfaceProject) throws InterfaceException;

	/**
	 * ڃ`FbNɏIɌĂяo<BR>
	 * 莩IɃC^[tF[X̕ύXȂǂsƂɎgp<BR>
	 * G[G[bZ[WInterfaceExceptionɃZbgē
	 *
	 * @param dataId
	 *            C^tF[XID
	 * @param dataMap
	 *            Sf[^}bv(L[FC^[tF[XAlFIDi[}bviL[FC^tF[XIDAlFڑli[}bvi
	 *            L[FږAlFljjj
	 * @param interfaceProject
	 *            C^tF[XvWFNg
	 * @throws InterfaceException
	 */
	public void afterCheckAttribute(int dataId, HashMap<String, TreeMap<Integer, HashMap<String, AttributeData>>> dataMap,
			InterfaceProject interfaceProject) throws InterfaceException;

	/**
	 * ڂ̃`FbNs<BR>
	 * G[G[bZ[WInterfaceExceptionɃZbgē
	 * G[ɂȂڂ̖͂OerrrorKeyListɒǉ
	 *
	 * @param dataId
	 *            C^tF[XID
	 * @param itemId
	 *            ACeID
	 * @param dataMap
	 *            li[}bviL[FږAlFlj
	 * @param interfaceProject
	 *            C^tF[XvWFNg
	 * @throws InterfaceException
	 */
	public void checkAttribute(int dataId, int itemId, HashMap<String, AttributeData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException;

	/**
	 * Ss̑ڂ̃`FbNs<BR>
	 * G[G[bZ[WInterfaceExceptionɃZbgē
	 *
	 * @param dataId
	 *            C^tF[XID
	 * @param dataMap
	 *            Sf[^}bv(L[FC^[tF[XAlFIDi[}bviL[FC^tF[XIDAlFڑli[}bvi
	 *            L[FږAlFljjj
	 * @param interfaceProject
	 *            C^tF[XvWFNg
	 * @throws InterfaceException
	 */
	public void checkAttribute(int dataId, HashMap<String, TreeMap<Integer, HashMap<String, AttributeData>>> dataMap,
			InterfaceProject interfaceProject) throws InterfaceException;

	/**
	 * t@C쐬
	 *
	 * @param dataMap
	 *            t@C쐬ɕKvȃp[^f[^}bviL[Fp[^L[AlFp[^f[^j
	 * @param interfaceProject
	 *            C^tF[XvWFNg
	 * @return 쐬ꂽt@CC[WIuWFNg
	 * @throws InterfaceException
	 */
	public AttributeFileImage create(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException;

	/**
	 * ݒʂŃCN[h̖ڂ͎gpȂ̊mF
	 *
	 * @return true=gp
	 */
	public boolean useDisableItemsAttribute();

}
