package jp.oarts.pirka.iop.tool.core.business;

import java.io.Serializable;
import java.util.HashMap;

import jp.oarts.pirka.iop.tool.core.general.constants.ParameterType;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.core.general.vo.Selecter;

/**
 * p[^C^[tF[X
 *
 * @author ito
 *
 */
public interface ParameterItem extends Serializable, Cloneable {

	/**
	 * p[^L[擾
	 *
	 * @return p[^L[
	 */
	public String getName();

	/**
	 * p[^{ꖼ擾
	 *
	 * @return p[^{ꖼ
	 */
	public String getNameJp();

	/**
	 * p[^bZ[W擾
	 *
	 * @return p[^bZ[W
	 */
	public String getMessage();

	/**
	 * p[^^Cv擾
	 *
	 * @return	p[^^Cv
	 */
	public ParameterType getParameterType();

	/**
	 * ړ͒擾
	 *
	 * @return ړ͒
	 */
	public int getLength();

	/**
	 * ftHgl擾
	 *
	 * @return	ftHgl
	 */
	public ParameterData getDefaultValue();

	/**
	 * ZNgpXg擾
	 *
	 * @return	ZNgpXg
	 */
	public Selecter[] getSelecter();

	/**
	 * ZNgpXgݒ
	 * @param	selecter
	 */
	public void setSelecter(Selecter[] selecter);

	/**
	 * ZNgpItO擾
	 * @return	ZNgpItO
	 */
	public boolean isMultiSelect();


	/**
	 * ZNgpItOݒ
	 * @param multiSelectFlag
	 */
	public void setMultiSelect(boolean multiSelectFlag);


	/**
	 * ͒l̃`FbN
	 *
	 * @param value
	 *            ͒l
	 * @throws InterfaceException
	 *             G[messageɃG[i[ē邱
	 */
	public void check(String value) throws InterfaceException;

	/**
	 * {^NbNꂽ̏
	 * @param	paramMap	p[^}bv
	 * @param	dataMap		f[^}bv
	 */
	public void clickButton(HashMap<String, ParameterItem> paramMap, HashMap<String, ParameterData> dataMap) throws InterfaceException;

	public Object clone();
}
