package jp.oarts.pirka.iop.tool.core.general.vo;

import java.io.Serializable;

/**
 * f[^
 *
 * @author ito
 *
 */
public class AttributeData implements Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;
	/**
	 * l
	 */
	private String value;

	/**
	 * RXgN^
	 */
	public AttributeData() {
		this.value = "";
	}

	/**
	 * RXgN^
	 *
	 * @param value
	 *            l
	 */
	public AttributeData(String value) {
		this.value = value;
	}

	/**
	 * RXgN^
	 *
	 * @param value
	 *            l
	 */
	public AttributeData(boolean value) {
		this.value = ((Boolean) value).toString();
	}

	/**
	 * RXgN^
	 *
	 * @param value
	 *            l
	 */
	public AttributeData(int value) {
		this.value = ((Integer) value).toString();
	}

	/**
	 * booleanl擾
	 *
	 * @return booleanl
	 */
	public Boolean getValueBoolean() {
		if (value != null) {
			return Boolean.valueOf(value);
		}
		return false;
	}

	/**
	 * intl擾
	 *
	 * @return intl
	 */
	public int getValueInt() {
		if (value != null) {
			try {
				return Integer.valueOf(value);
			} catch (NumberFormatException e) {
			}
		}
		return 0;
	}

	/**
	 * longl擾
	 *
	 * @return longl
	 */
	public long getValueLong() {
		if (value != null) {
			try {
				return Long.valueOf(value);
			} catch (NumberFormatException e) {
			}
		}
		return 0L;
	}

	/**
	 * Stringl擾
	 *
	 * @return value l
	 */
	public String getValue() {
		return value;
	}

	/**
	 * lZbg
	 *
	 * @param value
	 *            Zbg value
	 */
	public void setValue(String value) {
		this.value = value;
	}

}
