package jp.oarts.pirka.iop.tool.core.plugin.in.database;

import jp.oarts.pirka.iop.tool.core.general.constants.FieldType;
import jp.oarts.pirka.iop.tool.core.plugin.in.database.DatabaseInterfaceDesigner.DatabaseMetaInfo;
import jp.oarts.pirka.iop.tool.web.tools.IopUtil;

/**
 * H2p̕␳[`
 *
 * @author ito
 *
 */
public class H2ReviseType extends ReviseType {

	public H2ReviseType() {

		// preChnageFieldTypeMap.put("bpchar".toLowerCase(), "char");

		setLengthMapItem.put("DECIMAL".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_AND_DEC, 65535L, 32767));
		setLengthMapItem.put("NUMBER".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_AND_DEC, 65535L, 32767));
		setLengthMapItem.put("DEC".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_AND_DEC, 65535L, 32767));
		setLengthMapItem.put("NUMERIC".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_AND_DEC, 65535L, 32767));

		setLengthMapItem.put("BINARY".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("VARBINARY".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem
				.put("LONGVARBINARY".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("RAW".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("BYTEA".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("VARCHAR".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("LONGVARCHAR".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("VARCHAR2".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("NVARCHAR".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("NVARCHAR2".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("VARCHAR_CASESENSITIVE".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY,
				2147483647L, 0));
		setLengthMapItem.put("VARCHAR_IGNORECASE".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY,
				2147483647L, 0));
		setLengthMapItem.put("CHAR".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("CHARACTER".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("NCHAR".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("BLOB".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("TINYBLOB".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("MEDIUMBLOB".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("LONGBLOB".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("IMAGE".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("OID".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("CLOB".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("TINYTEXT".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("TEXT".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("MEDIUMTEXT".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("LONGTEXT".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("NTEXT".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("NCLOB".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));

		autoIncrementFieldTypeSet.add("identity".toLowerCase());

	}

	/**
	 * ŏIϊs
	 *
	 * @param info
	 */
	@Override
	protected void lastChange(DatabaseMetaInfo info) {
		// BIGINTŎCNgw肳ĂăftHg݂̃ftHg"(NEXT VALUE FOR PUBLIC.SYSTEM_SEQUENCE"݂
		// L[̂̂IdentityƂ݂ȂAftHgAL[
		// if ("BIGINT".equalsIgnoreCase(info.getFieldType()) &&
		// info.getAutoIncrement() != null
		// && info.getAutoIncrement() == true && info.getDefaultValue() != null
		// && info.getDefaultValue().trim().length() > 0
		// &&
		// info.getDefaultValue().indexOf("(NEXT VALUE FOR PUBLIC.SYSTEM_SEQUENCE")
		// >= 0 && info.isPrimaryKey()) {

		// BIGINTŃftHg݂̃ftHg"(NEXT VALUE FOR PUBLIC.SYSTEM_SEQUENCE"݂
		// L[̂̂IdentityƂ݂ȂAftHgAL[
		if ("BIGINT".equalsIgnoreCase(info.getFieldType()) && info.getDefaultValue() != null
				&& info.getDefaultValue().trim().length() > 0
				&& info.getDefaultValue().indexOf("(NEXT VALUE FOR PUBLIC.SYSTEM_SEQUENCE") >= 0 && info.isPrimaryKey()) {
			info.setFieldType("IDENTITY");
			info.setDefaultValue("");
			info.setPrimaryKey(true);
			info.setAutoIncrement(true);
			info.setSequenceName("");
			info.setLength(18);
			info.setSubLength(0);
			info.setNotNull(false);	//	DB쐬Serialŉʑ쎞͖́iftHgŃV[PXj\Ƃ̂ not null͂
		} else {
			if (info.getType() == FieldType.NUM && info.getDefaultValue() != null && info.getDefaultValue().length() > 0) {
				String sequenceName = IopUtil.getSequenceNameFromNextval(info.getDefaultValue());
				if (sequenceName != null) {
					info.setAutoIncrement(true);
					info.setSequenceName(sequenceName);
					info.setDefaultValue("");
				}
			}
		}

		if (info.getType() == FieldType.NUM && info.getLength() > 100) {
			info.setLength(20);
		}

		if (info.getType() == FieldType.NUM && info.getSubLength() > 100) {
			info.setSubLength(2);
		}

	}

}