package jp.oarts.pirka.iop.tool.core.tools.xml;

/**
 * VvXMLNX
 *
 * @author ito
 *
 */
public class XmlCreator extends XmlCreatorNode {

	/**
	 * RXgN^
	 */
	public XmlCreator() {
		super("");
	}

	/**
	 * XML𕶎ŕԂ
	 *
	 * @return 
	 */
	public String toString() {
		String lf = "\n";

		StringBuilder sb = new StringBuilder();
		sb.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + lf);
		for (XmlCreatorNode node : childNodes) {
			sb.append(node.toString(0));
		}
		return sb.toString();

	}

	public static void main(String[] args) {

		XmlCreator xml = new XmlCreator();
		XmlCreatorNode command = new XmlCreatorNode("command");
		command.putAttribute("name", "SystemStatus");
		xml.appendChild(command);

		XmlCreatorNode dayPatternNode = new XmlCreatorNode("dayPattern", "1");
		command.appendChild(dayPatternNode);

		XmlCreatorNode weatherNode = new XmlCreatorNode("weather", "2");
		command.appendChild(weatherNode);

		XmlCreatorNode testNode = new XmlCreatorNode("test", "abc&<>'\"");
		command.appendChild(testNode);

		XmlCreatorNode testNode2 = new XmlCreatorNode("test2");
		command.appendChild(testNode2);

		XmlCreatorNode testNodeA = new XmlCreatorNode("testA");
		command.appendChild(testNodeA);

		XmlCreatorNode testNodeB = new XmlCreatorNode("testB");
		testNodeA.appendChild(testNodeB);

		testNodeB.putAttribute("a", "");
		testNodeB.putAttribute("bbb", "0123456789");

		XmlCreatorNode testNodeC = new XmlCreatorNode("testC");
		testNodeB.appendChild(testNodeC);

		System.out.println(xml);

	}

}
