package jp.oarts.pirka.iop.tool.web.common;

import jp.oarts.pirka.core.kernel.FieldMap;
import jp.oarts.pirka.core.win.PirkaWindow;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.web.constants.Define;

/**
 * IOP-TOOSp̃x[XEBhE
 *
 * @author ito
 *
 */
public class IopBaseWindow extends PirkaWindow {
	/**
	 *
	 */
	private static final long serialVersionUID = 7803216047110095882L;

	/**
	 * `O
	 */
	public void preDraw() {

		String projectName = "";
		InterfaceProject interfaceProject = (InterfaceProject) getSession(Define.PROJECT_SESSION_NAME);
		if (interfaceProject != null) {
			//projectName = "project : " + interfaceProject.getNameJp() + " (" + interfaceProject.getName() + ")";
			projectName = interfaceProject.getNameJp() + " (" + interfaceProject.getName() + ")";
		}

		FieldMap fm = getFieldMap();
		fm.setValue("projectNameHeader", projectName);
		fm.setTagEffective("projectNameHeader", false);
		fm.setValue("verNo", jp.oarts.pirka.iop.tool.core.general.constants.Define.PROGRAM_VERSION_NO);
	}

	/**
	 * e[u^Op̃tB[hlZbg\bh<BR>
	 * Xy[Xɐݒ肵eWEBZ[t[hŏo͂
	 *
	 * @param fieldMap
	 *            tB[h}bv
	 * @param fieldName
	 *            tB[h
	 * @param value
	 *            l
	 * @param spaceValue
	 *            lXy[Xɏo͂镶iWEBZ[tj
	 */
	public void setString(FieldMap fieldMap, String fieldName, String value, String spaceValue) {
		if (value != null && value.trim().length() > 0) {
			fieldMap.setValue(fieldName, value);
			fieldMap.setSafeMode(fieldName, true);
		} else {
			fieldMap.setValue(fieldName, spaceValue);
			fieldMap.setSafeMode(fieldName, false);
		}

	}
}
