package jp.oarts.pirka.iop.tool.web.plugin;

import java.util.HashMap;

import jp.oarts.pirka.core.kernel.FieldMap;
import jp.oarts.pirka.core.res.PirkaRespons;
import jp.oarts.pirka.iop.tool.core.business.FileCreatorSampleModelerPlugin;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeFileImage;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.web.common.IopBaseWindow;

public class Execute extends IopBaseWindow {

	/**
	 *
	 */
	private static final long serialVersionUID = -4522943256446547395L;

	private ParameterInput returnWindow;

	private FileCreatorSampleModelerPlugin plugin;

	private HashMap<String, ParameterData> dataMap;

	private InterfaceProject interfaceProject;

	/**
	 * RXgN^
	 *
	 * @param plugin
	 *            vOC
	 */
	public Execute(ParameterInput returnWindow, FileCreatorSampleModelerPlugin plugin, HashMap<String, ParameterData> dataMap,
			InterfaceProject interfaceProject) {
		super();

		this.returnWindow = returnWindow;
		this.plugin = plugin;
		this.dataMap = dataMap;
		this.interfaceProject = interfaceProject;

		FieldMap fm = getFieldMap();
		fm.setValue("title", plugin.getNameJp());
	}

	/**
	 * ̉ʂ\瑦Ăяo
	 *
	 * @return	
	 */
	public PirkaRespons onElse() {

		try {
			AttributeFileImage fileImage = plugin.create(dataMap, interfaceProject);
			returnWindow.setExecResult(fileImage, null);
		} catch (InterfaceException e) {
			returnWindow.setExecResult(null, e.getMessage());
		}

		return returnWindow;
	}
}
