package jp.oarts.pirka.iop.tool.core.general.vo;

import java.io.Serializable;

import jp.oarts.pirka.iop.tool.core.general.constants.FieldType;

/**
 * C^[tF[Xځi`j
 *
 * @author ito
 *
 */
public class InterfaceDataMyItem implements Cloneable, Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 2293230413543278258L;

	/** j[NL[ */
	private int id;

	/** O */
	private String name;

	/** {ꖼ */
	private String nameJp;

	/** tB[h^Cv */
	private FieldType type;

	/** ڒ */
	private Long length;

	/** ڒ */
	private Integer subLength;

	/** L[͉zL[̃`FbN */
	private boolean primaryKey;

	/**
	 * RXgN^
	 *
	 * @param name
	 *            O
	 * @param nameJp
	 *            {ꖼ
	 * @param type
	 *            ^Cv
	 * @param length
	 *            
	 * @param subLength
	 *            _ȉ̒
	 */
	public InterfaceDataMyItem(String name, String nameJp, FieldType type, Long length, Integer subLength, boolean primaryKey) {
		this.id = 0;
		this.name = name;
		this.nameJp = nameJp;
		this.type = type;
		this.length = length;
		this.subLength = subLength;
		this.primaryKey = primaryKey;
	}

	/**
	 * RXgN^
	 *
	 * @param id
	 *            ID
	 * @param name
	 *            O
	 * @param nameJp
	 *            {ꖼ
	 * @param type
	 *            ^Cv
	 * @param length
	 *            
	 * @param subLength
	 *            _ȉ̒
	 */
	public InterfaceDataMyItem(int id, String name, String nameJp, FieldType type, Long length, Integer subLength, boolean primaryKey) {
		this.id = id;
		this.name = name;
		this.nameJp = nameJp;
		this.type = type;
		this.length = length;
		this.subLength = subLength;
		this.primaryKey = primaryKey;
	}

	@Override
	public Object clone() {
		try {
			return super.clone();
		} catch (CloneNotSupportedException e) {
			return null;
		}
	}

	/**
	 * @return id
	 */
	public int getId() {
		return id;
	}

	/**
	 * @return name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @return nameJp
	 */
	public String getNameJp() {
		return nameJp;
	}

	/**
	 * @return type
	 */
	public FieldType getType() {
		return type;
	}

	/**
	 * @return length
	 */
	public Long getLength() {
		return length;
	}

	/**
	 * @param id
	 *            Zbg id
	 */
	public void setId(int id) {
		this.id = id;
	}

	/**
	 * @param name
	 *            Zbg name
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @param nameJp
	 *            Zbg nameJp
	 */
	public void setNameJp(String nameJp) {
		this.nameJp = nameJp;
	}

	/**
	 * @param type
	 *            Zbg type
	 */
	public void setType(FieldType type) {
		this.type = type;
	}

	/**
	 * @param length
	 *            Zbg length
	 */
	public void setLength(Long length) {
		this.length = length;
	}

	/**
	 * @return subLength
	 */
	public Integer getSubLength() {
		return subLength;
	}

	/**
	 * @param subLength
	 *            Zbg subLength
	 */
	public void setSubLength(Integer subLength) {
		this.subLength = subLength;
	}

	/**
	 * @return the primaryKey
	 */
	public boolean isPrimaryKey() {
		return primaryKey;
	}

	/**
	 * @param primaryKey
	 *            the primaryKey to set
	 */
	public void setPrimaryKey(boolean primaryKey) {
		this.primaryKey = primaryKey;
	}

}
