package jp.oarts.pirka.iop.tool.core.general.vo;

import java.io.Serializable;

/**
 * p[^f[^
 *
 * @author ito
 *
 */
public class ParameterData implements Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * p[^l
	 */
	private String value;

	/**
	 * t@CC[W
	 */
	private byte[] fileImage;

	/**
	 * RXgN^
	 */
	public ParameterData() {
		this.value = "";
	}

	/**
	 * RXgN^
	 *
	 * @param value
	 *            p[^l
	 */
	public ParameterData(String value) {
		this.value = value;
	}

	/**
	 * RXgN^
	 *
	 * @param value
	 *            p[^l
	 */
	public ParameterData(int value) {
		this.value = "" + value;
	}

	/**
	 * RXgN^
	 *
	 * @param value
	 *            p[^l
	 */
	public ParameterData(boolean value) {
		this.value = ((Boolean) value).toString();
	}

	/**
	 * RXgbN^it@Cpj
	 *
	 * @param value
	 *            t@C
	 * @param fileImage
	 *            t@CC[W
	 */
	public ParameterData(String value, byte[] fileImage) {
		this.value = value;
		this.fileImage = fileImage;
	}

	/**
	 * booleanp[^l擾
	 *
	 * @return booleanp[^l
	 */
	public Boolean getValueBoolean() {
		if (value != null) {
			return Boolean.valueOf(value);
		}
		return false;
	}

	/**
	 * intp[^l擾
	 *
	 * @return booleanp[^l
	 */
	public int getValueInt() {
		if (value != null) {
			try {
				return Integer.valueOf(value);
			} catch (NumberFormatException e) {
			}
		}
		return 0;
	}

	/**
	 * longp[^l擾
	 *
	 * @return booleanp[^l
	 */
	public long getValueLong() {
		if (value != null) {
			try {
				return Long.valueOf(value);
			} catch (NumberFormatException e) {
			}
		}
		return 0L;
	}

	/**
	 * Stringp[^l擾
	 *
	 * @return p[^l
	 */
	public String getValue() {
		return value;
	}

	/**
	 * Stringp[^l擾iIpj
	 *
	 * @return p[^l
	 */
	public String[] getValues() {
		return value.split("\t");
	}

	/**
	 * t@CC[Wp[^l擾
	 *
	 * @return booleanp[^l
	 */
	public byte[] getFileImage() {
		return fileImage;
	}

	/**
	 * @param value
	 *            Zbg value
	 */
	public void setValue(String value) {
		this.value = value;
	}

	/**
	 * @param fileImage
	 *            Zbg fileImage
	 */
	public void setFileImage(byte[] fileImage) {
		this.fileImage = fileImage;
	}

}
