package jp.oarts.pirka.iop.tool.core.plugin.in.database;

import jp.oarts.pirka.iop.tool.core.general.constants.FieldType;
import jp.oarts.pirka.iop.tool.core.plugin.in.database.DatabaseInterfaceDesigner.DatabaseMetaInfo;

/**
 * Oraclep̕␳[`
 *
 * @author ito
 *
 */
public class OracleReviseType extends ReviseType {

	public OracleReviseType() {

		// preChnageFieldTypeMap.put("bpchar".toLowerCase(), "char");

		setLengthMapItem.put("CHAR".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 1L, 0));
		setLengthMapItem.put("VARCHAR2".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 1L, 0));
		setLengthMapItem.put("NCHAR".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 1L, 0));
		setLengthMapItem.put("NVARCHAR2".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 1L, 0));
		setLengthMapItem.put("NUMBER".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_AND_DEC, 22L, 0));

		// TIMESTAMPINTERVAL͒ɂĂ邩O
		// setLengthMapItem.put("TIMESTAMP".toLowerCase(), new
		// ChangeInfo(ChangeInfo.SET_LENGTH_MODE_DEC_ONLY, 0L, 6));
		// setLengthMapItem.put("TIMESTAMP WITH TIMEZONE".toLowerCase(), new
		// ChangeInfo(ChangeInfo.SET_LENGTH_MODE_DEC_ONLY, 0L, 6));
		// setLengthMapItem.put("TIMESTAMP WITH LOCAL TIMEZONE".toLowerCase(),
		// new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_DEC_ONLY, 0L, 6));
		// setLengthMapItem.put("INTERVAL YEAR TO MONTH".toLowerCase(), new
		// ChangeInfo(ChangeInfo.SET_LENGTH_MODE_DEC_ONLY, 0L, 6));
		// setLengthMapItem.put("INTERVAL DAY TO SECOND".toLowerCase(), new
		// ChangeInfo(ChangeInfo.SET_LENGTH_MODE_DEC_ONLY, 0L, 6));

		setLengthMapItem.put("RAW".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));

	}

	/**
	 * ŏIϊs
	 *
	 * @param info
	 */
	@Override
	protected void lastChange(DatabaseMetaInfo info) {
		// nachrnvarchar͔{̃tB[h擾ł̂Ŕɂ
		if ("nchar".equalsIgnoreCase(info.getFieldType()) || "nvarchar2".equalsIgnoreCase(info.getFieldType())) {
			info.setLength(info.getLength() / 2);
		}

		if (info.getType() == FieldType.NUM && info.getLength() > 100) {
			info.setLength(20);
		}

		if (info.getType() == FieldType.NUM && info.getSubLength() > 100) {
			info.setSubLength(2);
		}

		//	oraclełdefaultɃV[PXLqłȂ
//		if(info.getDefaultValue() != null && info.getDefaultValue().length() > 0){
//			String defVal = IopUtil.cutSqlString(info.getDefaultValue().trim().toLowerCase());
//			if(defVal.indexOf("nextval.") >= 0 ){
//				info.setAutoIncrement(true);
//			}
//		}
	}

	/**
	 * Œ萔l̎Ɍ^`̕ϊs̃`FbN
	 *
	 * @param info
	 * @param ci
	 * @return true=^`̕ϊKv
	 */
	@Override
	protected boolean numberChangeCheck(DatabaseMetaInfo info, ChangeInfo ci) {
		return info.getLength() != ci.getDefaultLength() || info.getSubLength() != ci.getDefaultSubLength()
				|| !info.isSubLenWasNull();
	}

}