package jp.oarts.pirka.iop.tool.web.common;

import jp.oarts.pirka.core.kernel.FieldMap;
import jp.oarts.pirka.core.res.PirkaRespons;

/**
 * Alert
 *
 * @author ito
 *
 */
public class Alert extends IopBaseWindow {

	private PirkaRespons nextWindow;

	/**
	 * mF
	 *
	 * @param message
	 *            bZ[W
	 */
	public Alert(String message) {
		this("", message);
	}

	/**
	 * mF
	 *
	 * @param title
	 *            mFʂ̃^Cg
	 * @param message
	 *            bZ[W
	 */
	public Alert(String title, String message) {
		this(null, title, message);
	}

	/**
	 * mF
	 *
	 * @param nextWindow
	 *            EBhE
	 * @param title
	 *            ^Cg
	 * @param message
	 *            bZ[W
	 */
	public Alert(PirkaRespons nextWindow, String title, String message) {
		this(nextWindow, title, message, null);
	}

	/**
	 * mF
	 *
	 * @param nextWindow
	 *            EBhE
	 * @param title
	 *            ^Cg
	 * @param message
	 *            bZ[W
	 * @param buttonName
	 *            {^
	 */
	public Alert(PirkaRespons nextWindow, String title, String message, String buttonName) {
		this.nextWindow = nextWindow;

		FieldMap fm = getFieldMap();

		fm.setValue("title", title);
		fm.setValue("message", message);
		if (buttonName != null) {
			fm.setValue("yes", buttonName);
		}
	}

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * ͂{^NbNꂽ̏
	 *
	 * @return ʓ
	 */
	public PirkaRespons yes() {
		return nextWindow;
	}

}
